.syntax unified
.thumb
.thumb_func
.code 16
//.text

//********************* (C) COPYRIGHT 2009 e-Design Co.,Ltd. *********************
// File Name : ASM.c       
// Version   : DS203_APP Ver 2.5x                                Author : bure
//******************************************************************************//

BIOS:
//===============================================================================
//                        System function entrance
//===============================================================================
// void CTR_HP(void)     USB_HP_Interrupt
//-------------------------------------------------------------------------------
  .globl  __CTR_HP
.thumb_func
    . = BIOS + 0x01
__CTR_HP:
//===============================================================================
// void USB_Istr(void)   USB_LP_Interrupt
//-------------------------------------------------------------------------------
  .globl  __USB_Istr
.thumb_func
    . = BIOS + 0x05
__USB_Istr:
//===============================================================================
// void __LCD_Initial(void)  
//-------------------------------------------------------------------------------
  .globl  __LCD_Initial 
.thumb_func
    . = BIOS + 0x09
__LCD_Initial :
//===============================================================================
// void __Point_SCR(u16 x0, u16 y0)  
//-------------------------------------------------------------------------------
  .globl  __Point_SCR 
.thumb_func
    . = BIOS + 0x0D
__Point_SCR :
//===============================================================================
// void __LCD_SetPixl(u16 Color)  
//-------------------------------------------------------------------------------
  .globl  __LCD_SetPixl 
.thumb_func
    . = BIOS + 0x11
__LCD_SetPixl :
//===============================================================================
// void __Clear_Screen(u16 Color)  
//-------------------------------------------------------------------------------
  .globl  __Clear_Screen 
.thumb_func
    . = BIOS + 0x15
__Clear_Screen :
//===============================================================================
// u16 __Get_TAB_8x14(u8 Code, u16 Row)  
//-------------------------------------------------------------------------------
  .globl  __Get_TAB_8x14 
.thumb_func
    . = BIOS + 0x19
__Get_TAB_8x14 :
//===============================================================================
// void __LCD_Set_Block(u16 x1, u16 x2, u16 y1, u16 y2)  
//-------------------------------------------------------------------------------
  .globl  __LCD_Set_Block 
.thumb_func
    . = BIOS + 0x1D
__LCD_Set_Block :
//===============================================================================
// void __LCD_DMA_Ready(void)  Wait LCD data DMA ready
//-------------------------------------------------------------------------------
  .globl  __LCD_DMA_Ready 
.thumb_func
    . = BIOS + 0x21
__LCD_DMA_Ready :
//===============================================================================
// void __LCD_Copy(uc16 *pBuffer, u16 NumPixel)  Send a row data to LCD
//-------------------------------------------------------------------------------
  .globl  __LCD_Copy
.thumb_func
    . = BIOS + 0x25
__LCD_Copy:
//===============================================================================
// void __LCD_Fill(u16  *pBuffer, u16 NumPixel)  Fill number of pixel by DMA 
//-------------------------------------------------------------------------------
  .globl  __LCD_Fill
.thumb_func
    . = BIOS + 0x29
__LCD_Fill:
//===============================================================================
// void __Row_DMA_Ready(void)  Wait row base data DMA ready
//-------------------------------------------------------------------------------
  .globl  __Row_DMA_Ready 
.thumb_func
    . = BIOS + 0x2D
__Row_DMA_Ready :
//===============================================================================
// void __Row_Copy(uc16 *S_Buffer,u16 *T_Buffer) Copy one row base data to buffer
//-------------------------------------------------------------------------------
  .globl  __Row_Copy
.thumb_func
    . = BIOS + 0x31
__Row_Copy:
//===============================================================================
// u32 __Read_FIFO(void) 
//-------------------------------------------------------------------------------
  .globl  __Read_FIFO
.thumb_func
    . = BIOS + 0x35  
__Read_FIFO:
//===============================================================================
// u32 __Input_Lic(u16 x0, u8 y0, u16 Color)//  Return: 32Bits Licence 
//-------------------------------------------------------------------------------
  .globl  __Input_Lic
.thumb_func
    . = BIOS + 0x39
__Input_Lic:
//===============================================================================
// u32 GetDev_SN(void)//  Get 32bits Device Serial Number
//-------------------------------------------------------------------------------
  .globl  __GetDev_SN
.thumb_func
    . = BIOS + 0x3D
__GetDev_SN:
//===============================================================================
// u8 __Chk_SYS(u32 Licence)   Check SYS licence            RET: 1 = licence ok
//-------------------------------------------------------------------------------
  .globl  __Chk_SYS
.thumb_func
    . = BIOS + 0x41
__Chk_SYS:
//===============================================================================
// u8 __Ident(u32 Dev_ID, u32 Proj_ID, u32 Lic_No)          RET: 1 = licence ok
//-------------------------------------------------------------------------------
  .globl  __Ident
.thumb_func
    . = BIOS + 0x45
__Ident:
//===============================================================================
// void __Display_Str(u16 x0, u16 y0, u16 Color, u8 Mode, u8 *s)                      
//-------------------------------------------------------------------------------
  .globl  __Display_Str
.thumb_func
    . = BIOS + 0x49
__Display_Str:
//===============================================================================
// void __Set(u8 Device, u32 Value)            Hardware control device Settings
//-------------------------------------------------------------------------------
  .globl  __Set
.thumb_func
    . = BIOS + 0x4D 
__Set:
//===============================================================================
// void Set_Param(u8 RegAddr, u8 Parameter)       Trigger control parameter set
//-------------------------------------------------------------------------------
  .globl  __Set_Param
.thumb_func
    . = BIOS + 0x51 
__Set_Param:
//===============================================================================
// u32 __Get(u8 Kind)                           Get hardware attribute & status
//-------------------------------------------------------------------------------
  .globl  __Get
.thumb_func
    . = BIOS + 0x55
__Get:
//===============================================================================
// void __ExtFlash_PageWR(u8* pBuffer, u32 WriteAddr)//
//-------------------------------------------------------------------------------
  .globl  __ExtFlash_PageWR
.thumb_func
    . = BIOS + 0x59
__ExtFlash_PageWR:
//===============================================================================
// void __Disk_Buff_RD(u8* pBuffer, u32 ReadAddr, u16 NumByteToRead)//
//-------------------------------------------------------------------------------
  .globl  __ExtFlash_PageRD
.thumb_func
    . = BIOS + 0x5D
__ExtFlash_PageRD:
//===============================================================================
// u8 ReadDiskData(u8* pBuffer, u32 ReadAddr, u16 Lenght)
//-------------------------------------------------------------------------------
  .globl  __ReadDiskData
.thumb_func
    . = BIOS + 0x61
__ReadDiskData:
//===============================================================================
// u8 ProgDiskPage(u8* pBuffer, u32 ProgAddr)
//-------------------------------------------------------------------------------
  .globl  __ProgDiskPage
.thumb_func
    . = BIOS + 0x65
__ProgDiskPage:
//===============================================================================
// u16 __LCD_GetPixl(void)  
//-------------------------------------------------------------------------------
  .globl  __LCD_GetPixl 
.thumb_func
    . = BIOS + 0x69
__LCD_GetPixl :
//===============================================================================
	// void __USB_Init(void)                      
//-------------------------------------------------------------------------------
  .globl  __USB_Init
.thumb_func
    . = BIOS + 0x6D
__USB_Init:
//===============================================================================
// u8 __FLASH_Erase(u32 Address)                                    RET: 1 = ok
//-------------------------------------------------------------------------------
  .globl  __FLASH_Erase
.thumb_func
    . = BIOS + 0x71
__FLASH_Erase:
//===============================================================================
// u8 __FLASH_Prog(u32 Address, u16 Data)                           RET: 1 = ok    
//-------------------------------------------------------------------------------
  .globl  __FLASH_Prog
.thumb_func
    . = BIOS + 0x75
__FLASH_Prog:
//===============================================================================
// void __FLASH_Unlock(void)
//-------------------------------------------------------------------------------
  .globl  __FLASH_Unlock
.thumb_func
    . = BIOS + 0x79
__FLASH_Unlock:
//===============================================================================
// void __FLASH_Lock(void)
//-------------------------------------------------------------------------------
  .globl  __FLASH_Lock
.thumb_func
    . = BIOS + 0x7D
__FLASH_Lock:
//===============================================================================
// u8*  __Chk_DFU(void)
//-------------------------------------------------------------------------------
  .globl  __Chk_DFU
.thumb_func
    . = BIOS + 0x81
__Chk_DFU:
//===============================================================================
// u8*  __Chk_HDW(void)
//-------------------------------------------------------------------------------
  .globl  __Chk_HDW
.thumb_func
    . = BIOS + 0x85
__Chk_HDW:
//===============================================================================
// u8 __OpenFileWr(u8* Buffer, u8* FileName, u16* Cluster, u32* pDirAddr)//
//-------------------------------------------------------------------------------
  .globl  __OpenFileWr
.thumb_func
    . = BIOS + 0x89
__OpenFileWr:
//===============================================================================
// u8 __OpenFileRd(u8* Buffer, u8* FileName, u16* Cluster, u32* pDirAddr)//
//-------------------------------------------------------------------------------
  .globl  __OpenFileRd
.thumb_func
    . = BIOS + 0x8D
__OpenFileRd:
//===============================================================================
// u8 __ReadFileSec(u8* Buffer, u16* Cluster)//
//-------------------------------------------------------------------------------
  .globl  __ReadFileSec
.thumb_func
    . = BIOS + 0x91
__ReadFileSec:
//===============================================================================
// u8 __ProgFileSec(u8* Buffer, u16* Cluster)//
//-------------------------------------------------------------------------------
  .globl  __ProgFileSec
.thumb_func
    . = BIOS + 0x95
__ProgFileSec:
//===============================================================================
// u8 __CloseFile(u8* Buffer, u32 Lenght, u16* Cluster, u32* pDirAddr)//
//-------------------------------------------------------------------------------
  .globl  __CloseFile
.thumb_func
    . = BIOS + 0x99
__CloseFile:
//===============================================================================
// void __Row_Fill(uc16 *S_Buffer,u16 *T_Buffer) Fill one row base data to buffer
//-------------------------------------------------------------------------------
  .globl  __Row_Fill
.thumb_func
    . = BIOS + 0x9D
__Row_Fill:
//===============================================================================
    
//******************************* END OF FILE ***********************************
